// Copyright (C) 2000 Dominic Letourneau (doumdi@yahoo.com)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this file.  If not, write to the Free Software Foundation,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef _CHANNEL_SEPARATOR_H_
#define _CHANNEL_SEPARATOR_H_

#include "Node.h"
#include "GreyScale8Image.h"
#include "RGB24Image.h"

class ChannelSeparator : public Node
{

public:
		
  ChannelSeparator(string nodeName, ParameterSet params);
  
  virtual ~ChannelSeparator();
   
  virtual ObjectRef getOutput(int output_id, int count); 

private:

  int m_IMAGE_ID;     	
  ObjectRef m_RED;
  ObjectRef m_GREEN;
  ObjectRef m_BLUE;
  
  // Default constructor, should not be used
  ChannelSeparator() {throw(GeneralException("ChannelSeparator default constructor should not be called",__FILE__,__LINE__));}
  
};

#endif
