// Copyright (C) 2000 Dominic Letourneau (doumdi@yahoo.com)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this file.  If not, write to the Free Software Foundation,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#ifndef _CONVOLUTION_H
#define _CONVOLUTION_H



#include "Node.h"
#include "GreyScale8Image.h"
#include "Kernel.h"



class Convolution : public Node
{
public:
		
  Convolution(string nodeName, ParameterSet params);
  
  virtual ~Convolution();
  
  GreyScale8Image* convolve(GreyScale8Image &im, Kernel &kernel);
  
  virtual ObjectRef getOutput(int output_id, int count); 

private:


	int m_KERNEL_ID;		
	int m_IMAGE_ID;     	
	ObjectRef m_output;	

	// Default constructor, should not be used
	Convolution() {throw(GeneralException("Convolution default constructor should not be called",__FILE__,__LINE__));}

};

#endif
