// Copyright (C) 2000 Dominic Letourneau (doumdi@yahoo.com)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this file.  If not, write to the Free Software Foundation,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#ifndef _KERNEL_CC_
#define _KERNEL_CC_

#include "Kernel.h"
#include <string>
#include <strstream.h>  


NODE_INFO(KernelConst,"Image", "", "KERNEL_OUT", "SIZE:VALUES")

KernelConst::KernelConst(string nodeName, ParameterSet params)
: Node(nodeName, params)
  , m_values (parameters.get("VALUES"))
  , m_size (parameters.get("SIZE"))
{
  try {
   
 
    // Add the node's output
    addOutput("KERNEL_OUT");

    String val_string = object_cast<String>(m_values);
    int size = object_cast<Int>(m_size).val();

    Kernel *k = new Kernel(size);

    //to be continued
    char number[24];
    int *data = k->get_data();
    istrstream st(val_string.c_str());

   

    for (int i = 0; i < size * size; i++) {
      st>>number;
      *data = atoi(number);
      data++;
    }
    

    m_output = ObjectRef(k);

  }
  catch (BaseException *e) {
    //Something weird happened
    //e->print();
    throw e->add(new NodeException (this,
				    string("error caught in KernelConst constructor"), 
				    __FILE__,__LINE__));
  }  
}

KernelConst::~KernelConst()
{
  return;
}

ObjectRef KernelConst::getOutput (int output_id, int count) {

  if (!hasOutput(output_id)) throw new NodeException (this, "Cannot getOutput id",__FILE__,__LINE__);
    
  return (m_output);
  
} 
#endif
